
/*
 ******************************************
 **    © by Widgetschmie.de 2005-2008    **
 ******************************************
 */

var filterArray = new Array();					// holds all our filters. Each array-value is an object
var theseFiltersHaveChanged = new Array();		// holds the filters that changed and need to be re-applied. Causes saveFilters to be called when we close the prefs


// shows or hides the message to add filters
function showHideFilterMessage() {
	var parent = getObj("filters");
	var msg = getObj("filtersHint");
	if(parent && msg) {
		if(getElementNodes(parent).length > 1) {			// the message itself is also a child of this node!
			msg.style.display = 'none';
		}
		else {
			msg.style.display = 'block';
		}
	}
}



// shows a sheet with the values of one filter
var editingFilter = -1;
var filterSheetShown = false;
function editFilter(index) {
	var form = getObj("WSprefs_layer_filters");
	if(!form) {
		alert('filter-form not found');
		return;
	}
	
	// edit filter
	if(index >= 0 && filterArray[index]) {
		editingFilter = index;
		filterArray[index].edit();
	}
	
	// new filter
	else {
		form.elements["filter_string"].value = '';
		setFilterOnlyInChannel(0);
		form.elements["filter_only_title"].checked = false;
		form.elements["filter_also_cast"].checked = true;
		form.elements["filter_mark_show"].checked = true;
		form.elements["filter_set_alert"].checked = false;
	}
	
	form.elements["filter_string"].focus();
	filterSheetShown = true;
	showSheet("filters_sheet");
}


// toggles a property for a filter
function toggleFilterProp(filter_id, property) {
	var filter = filterWithID(filter_id);
	if(!filterSheetShown && filter) {
		filter.toggleProp(property);
		theseFiltersHaveChanged.push(filter_id);
	}
}


function setFilterOnlyInChannel(channel) {
	var obj = getObj("filter_only_channel");
	var elements = obj.options;
	if(!elements.length > 0) {
		addAssignedChannelsToSelector('filter_only_channel', 'filter_list');
	}
	
	if(!channel)
		channel = 0;
	
	var found = false;
	for(var i = 0; i < elements.length; i++) {
		if(elements[i].value == channel) {
			elements[i].selected = true;
			setFilterOnlyInChannelText(elements[i].innerHTML);
			found = true;
		}
		else
			elements[i].selected = false;
	}
	
	// channel not found - select "in all channels"
	if(!found) {
		elements[0].selected = true;
		setFilterOnlyInChannelText(elements[0].innerHTML);
	}
}

function setFilterOnlyInChannelText(text) {
	var obj = getObj("filter_only_channel_cover");
	obj.innerHTML = (text == locStr('in allen Sendern')) ? text :
							(text == locStr('channelGroup1') || text == locStr('channelGroup2')) ? locStr("in") + ' ' + text : locStr("auf") + ' ' + text;
}


// sets properties for a filter from the values on the sheet
function saveFilter() {
	var form = getObj("WSprefs_layer_filters");
	
	if(form.elements["filter_string"].value.length <= 1) {
		FernsehPlugin.beep();
		form.elements["filter_string"].value = locStr("Suchtext");
		form.elements["filter_string"].select();
		return;
	}
	
	var string = form.elements["filter_string"].value;
	var channel = form.elements["filter_only_channel"].value;
	var title_only = form.elements["filter_only_title"].checked;
	var also_cast = form.elements["filter_also_cast"].checked;
	var mark = form.elements["filter_mark_show"].checked;
	var set_alert = form.elements["filter_set_alert"].checked;
	
	// edit existing filter
	if(editingFilter >= 0 && filterArray[editingFilter]) {
		filterArray[editingFilter].setValues(string, channel, title_only, also_cast, mark, set_alert);
		filterArray[editingFilter].update();
		theseFiltersHaveChanged.push(filterArray[editingFilter].id);
	}
	
	// add a new one
	else {
		var filter = new filterObj('', string, channel, title_only, also_cast, mark, set_alert);
		getObj("filters").appendChild(filter.getRepresentation());
		theseFiltersHaveChanged.push(filter.id);
	}
	
	showHideFilterMessage();
	hideNewFilterSheet();
}


function hideNewFilterSheet() {
	editingFilter = -1;
	filterSheetShown = false;
	hideSheet("filters_sheet");
}


// deletes a filter
function removeFilter(num) {
	if(filterArray[num]) {
		filterArray[num].remove();
	}
}



// loads the filters from the prefs
function loadFilters() {
	if(window.widget) {
		prefvalue = widget.preferenceForKey("show_filters");
		if(prefvalue) {
			var savedFilters = Deserialize(prefvalue);			// saved as an array
			
			for(var i = 0; i < savedFilters.length; i++) {
				var filter_id = savedFilters[i]['id'];
				var string = savedFilters[i]['string'];
				var channel = savedFilters[i]['channel'];
				var title_only = savedFilters[i]['title_only'];
				var also_cast = savedFilters[i]['also_cast'];
				var mark = savedFilters[i]['mark'];
				var set_alert = savedFilters[i]['setAlert'];
				
				new filterObj(filter_id, string, channel, title_only, also_cast, mark, set_alert);
			}
		}
	}
	
	// show in prefs
	if(filterArray && filterArray.length > 0) {
		var parent = getObj('filters');
		for(var p = 0; p < filterArray.length; p++) {
			if(filterArray[p]) {
				var div = filterArray[p].getRepresentation();
				parent.appendChild(div);
			}
		}
		
		showHideFilterMessage();
	}
}


// save the filters
function saveFilters() {
	if(theseFiltersHaveChanged && theseFiltersHaveChanged.length > 0) {
		var saveFilters = new Array();
		var poss_filters = getElementNodes(getObj('filters'));
		
		// really delete filters marked 'deleted'
		for(var i = (filterArray.length - 1); i >= 0; i--) {
			if(filterArray[i] && filterArray[i].deleted) {
				filterArray.splice(i, 1);
			}
		}
		
		// save filters
		for(var i = 0; i < poss_filters.length; i++) {
			var id = poss_filters[i].getAttribute('id');
			if("filterSetting_" == id.substr(0, 14)) {
				var num = id.substr(14);
				if(filterArray[num] && !filterArray[num].deleted) {
					saveFilters.push(filterArray[num].serializable());
				}
			}
		}
		
		applyFiltersToShows();
		widget.setPreferenceForKey(Serialize(saveFilters), "show_filters");
	}
}


// lets the Plugin update the filters
function applyFiltersToShows(show_ids) {
	var filter_strings = new Array();
	theseFiltersHaveChanged = array_unique(theseFiltersHaveChanged);
	
	// update only some filters
	if(theseFiltersHaveChanged && theseFiltersHaveChanged.length > 0) {
		for(var i = 0; i < theseFiltersHaveChanged.length; i++) {
			var filter = filterWithID(theseFiltersHaveChanged[i]);
			if(filter) {
				filter_strings.push(filter.getFilterPluginString());
			}
			else {
				filter_strings.push("filterid::" + theseFiltersHaveChanged[i] + "\nstring::##deleted");
			}
		}
	}
	
	// update all filters
	else {
		for(var i = 0; i < filterArray.length; i++) {
			filter_strings.push(filterArray[i].getFilterPluginString());
		}
	}
	
	theseFiltersHaveChanged = new Array();
	
	if(filter_strings.length > 0) {
		FernsehPlugin.applyFiltersToShows(filter_strings.join("\n\n"), (show_ids && show_ids.length > 0) ? show_ids.join(',') : '');
	}
	setTimeout("updateFilterBadge()", 20);
}


// gets a filter by ID
function filterWithID(filter_id) {
	for(var i = 0; i < filterArray.length; i++) {
		if(filterArray[i].id == filter_id) {
			return filterArray[i];
		}
	}
	return null;
}


// does what the name says
function updateFilterBadge()
{
	var numHits = FernsehPlugin.filteredShows().length;
		
	var obj = getObj("filtercount");
	obj.innerHTML = numHits;
	obj.style.display = (0 == numHits) ? "none" : "block";
}









/*
 *
 *	The filter-Class
 *
 */

function filterObj(filter_id, string, channel, title_only, also_cast, mark, set_alert) {
	if(! this instanceof filterObj) {
		return new filterObj(filter_id, string, channel, title_only, also_cast, mark, set_alert);
	}
	
	if('object' != typeof filterArray)
		return null;
	
	// Attributes
	this.num = filterArray.length;
	this.deleted = false;
	
	this.id = filter_id ? filter_id : 'xxx';
	if('xxx' == this.id) {
		var part1 = (new Date()).getTime();		// like: 1207255413525
		var part2 = Math.floor(Math.random() * 1000);
		this.id = part1 + "" + part2;
	}
	this.string = string;
	this.channel = channel;
	this.title_only = title_only ? 1 : 0;
	this.also_cast = also_cast ? 1 : 0;
	this.mark = mark ? 1 : 0;
	this.set_alert = set_alert ? 1 : 0;
	
	this.div = null;
	this.text = null;
	this.details = null;
	
	
	// Methods
	this.setValues = function(string, channel, title_only, also_cast, mark, set_alert) {
		this.string = string ? string : "no string!";
		this.channel = channel;
		this.title_only = title_only ? 1 : 0;
		this.also_cast = also_cast ? 1 : 0;
		this.mark = mark ? 1 : 0;
		this.set_alert = set_alert ? 1 : 0;
	}
	
	this.serializable = function() {
		var hash = new Object();
		hash['id'] = this.id;
		hash['string'] = this.string;
		hash['channel'] = this.channel;
		hash['title_only'] = this.title_only;
		hash['also_cast'] = this.also_cast;
		hash['mark'] = this.mark;
		hash['setAlert'] = this.set_alert;
		
		return hash;
	}
	
	// get the div
	this.getRepresentation = function() {
		var div = document.createElement('div');
		div.setAttribute("id", "filterSetting_" + this.num);
		div.setAttribute("class", "divDrag_item filter_line");
		//div.setAttribute("onmouseover", "divDragHover(event)");
		
		var remove = document.createElement("img");
		remove.setAttribute("class", "removeknob");
		remove.setAttribute("src", "Images/Cross.png");
		remove.setAttribute("alt", "x");
		remove.setAttribute("onclick", "removeFilter(" + this.num + ")");
		
		var text = document.createElement("span");
		text.innerHTML = this.string ? this.string : "Filter";
		text.setAttribute("class", "divDrag_titlespan filter_title");
		text.setAttribute("onmousedown", "theseFiltersHaveChanged.push('" + this.id + "'); divDragDown(event)");
		text.setAttribute("ondblclick", "editFilter(" + this.num + ")");
		this.text = text;
		
		// detailed info
		this.getDetailedInfo();
		
		// compose
		div.appendChild(remove);
		div.appendChild(this.details);
		div.appendChild(this.text);
		
		// done
		this.div = div;
		return this.div;
	}
	
	this.getDetailedInfo = function() {
		var info = document.createElement("div");
		info.setAttribute("class", "filter_info");
		
		if(this.channel && (this.channel != 0)) {
			var div = document.createElement('div');
			var channel = document.createElement("img");
			channel.setAttribute("src", "Images/AirWaves.png");
			channel.setAttribute("alt", locStr("Sender"));
			div.appendChild(channel);
			if("channelGroup1" == this.channel || "channelGroup2" == this.channel) {
				var chan = document.createTextNode(locStr(this.channel));
			}
			else {
				var chan = document.createTextNode(availableChannels[this.channel] ? availableChannels[this.channel].getName() : "unknown channel");
			}
			div.appendChild(chan);
			info.appendChild(div);
		}
		
		var ttl = document.createElement("img");
		ttl.setAttribute("class", "filter_icon");
		ttl.setAttribute("onclick", "toggleFilterProp(" + this.id + ", 'title_only')");
		ttl.setAttribute("src", this.title_only ? "Images/T.png" : "Images/T_inactive.png");
		ttl.setAttribute("alt", "?");
		info.appendChild(ttl);
		
		var cast = document.createElement("img");
		cast.setAttribute("class", "filter_icon");
		cast.setAttribute("onclick", "toggleFilterProp(" + this.id + ", 'also_cast')");
		cast.setAttribute("src", this.also_cast ? "Images/cast.png" : "Images/castOff.png");
		cast.setAttribute("alt", "?");
		info.appendChild(cast);
		
		var al = document.createElement("img");
		al.setAttribute("class", "filter_icon");
		al.setAttribute("onclick", "toggleFilterProp(" + this.id + ", 'alarm')");
		al.setAttribute("src", this.set_alert ? "Images/AlarmOn.png" : "Images/AlarmOff.png");
		al.setAttribute("alt", "?");
		info.appendChild(al);
		
		var mark = document.createElement("img");
		mark.setAttribute("class", "filter_icon");
		mark.setAttribute("onclick", "toggleFilterProp(" + this.id + ", 'mark')");
		mark.setAttribute("src", this.mark ? "Images/mark.png" : "Images/markOff.png");
		mark.setAttribute("alt", "?");
		info.appendChild(mark);
		
		this.details = info;
		return this.details;
	}
	
	this.update = function() {
		if(this.text) {
			this.text.innerHTML = this.string;
		}
		this.updateDetails();
	}
	
	this.updateDetails = function() {
		if(this.div) {
			if(this.details) {
				this.div.removeChild(this.details);
				this.details = null;
			}
			
			this.getDetailedInfo();
			if(this.text) {
				this.div.insertBefore(this.details, this.text);
			}
			else {
				this.div.appendChild(this.details);
			}
		}
	}
	
	
	this.edit = function() {
		var form = getObj("WSprefs_layer_filters");
		if(form) {
			form.elements["filter_string"].value = this.string;
			setFilterOnlyInChannel(this.channel);
			form.elements["filter_only_title"].checked = this.title_only;
			form.elements["filter_also_cast"].checked = this.also_cast;
			form.elements["filter_mark_show"].checked = this.mark;
			form.elements["filter_set_alert"].checked = this.set_alert;
		}
	}
	
	this.toggleProp = function(property) {
		switch(property) {
			case 'title_only':
				this.title_only = !this.title_only;		break;
			case 'also_cast':
				this.also_cast = !this.also_cast;		break;
			case 'alarm':
				this.set_alert = !this.set_alert;		break;
			case 'mark':
				this.mark = !this.mark;			break;
		}
		
		this.updateDetails();
	}
	
	
	// removes the draggable div
	this.remove = function() {
		var parent = this.div.parentNode;
		if(!parent || filterSheetShown)
			return;
			
		// show poof
		var event = window.event;
		showPoof(event.x, event.y);
		
		// remove it (and push it to theseFiltersHaveChanged!)
		theseFiltersHaveChanged.push(this.id);
		this.div.style.opacity = 0;
		this.deleted = true;
		
		setTimeout("filterArray[" + this.num + "].removed()", 500);		// after 500ms, the poof has finished
		setTimeout("showHideFilterMessage()", 520);
	}
	
	this.removed = function() {
		if(this.div) {
			this.div.parentNode.removeChild(this.div);
			this.div = null;
			this.details = null;
			this.deleted = true;
		}
	}
	
	this.getFilterPluginString = function() {
		var channelNames = new Array();
		
		if(this.channel && (this.channel != 0)) {
			if("channelGroup1" == this.channel || "channelGroup2" == this.channel) {
				channelNames = window[this.channel];		// this gets one of those two arrays
			}
			else if(availableChannels[this.channel]) {
				channelNames.push(this.channel);
			}
		}
		var serialized = (channelNames.length > 0) ? "channels::" + channelNames.join(",") + "\n" : '';
		serialized += "filterid::" + this.id + "\nstring::" + this.string + "\ntitle_only::" + (this.title_only ? 1 : 0) + "\nalso_cast::" + (this.also_cast ? 1 : 0) + "\nalarm::" + (this.set_alert ? 1 : 0) + "\nmark::" + (this.mark ? 1 : 0);
		
		return serialized;
	}
		
	this.displayFilterHeader = function()
	{
		var parent = getObj("content");
		
		// main <p>
		var paragraph = document.createElement("p");
		paragraph.setAttribute("class", "dateRow");
		var headerTitle = document.createTextNode(this.string);
		paragraph.appendChild(headerTitle);
	
		parent.appendChild(paragraph);
	}
	
	
	// Add
	filterArray.push(this);
	return this;
}
